(function ($, Drupal, once) {


  function feature_50_50() {

    var $feature_split_para = jQuery(".paragraph--type--feature-split");

    $feature_split_para.each(function () {
      jQuery(this).find(".tabs-dd").show();
      var height = jQuery(this).find(".tabs-dropdown").outerHeight();

      var h_desktop = 160 + height;
      var h_mobile = 160 + height;
      if (jQuery(window).width() > 767) {
        jQuery(this).find(".tab .splitWithDropdown__textContent").css("padding-top", "" + h_desktop + "px");
      }
      else {
        jQuery(this).find(".tab .splitWithDropdown__textContent").css("padding-top", "" + h_mobile + "px");
      }
    });
  }

  function fliterTags(item) {
    jQuery(".blog__filterTags--tag[data-tid=" + item + "]").addClass("active");
  }

  jQuery(document).ready(function () {
    // Article Has Hero
    if (jQuery(".layout-content-top").find(".blogHero").length == 0) {
      jQuery("body").addClass("has-no-hero");
    }

    // Social Wall
    jQuery(".stayConnect__card").each(function () {
      jQuery(this).css("background-image", "url('" + jQuery(this).data('img') + "')");
    });

    // Table Wrapping JS
    jQuery(document).find("table").each(function () {
      jQuery(this).wrap("<div class='financialTable'><div class='octagon fullWidth smallPadding'></div></div>");
      jQuery(this).parent().append('<div class="tb"></div><div class="topAngles"></div><div class="bottomAngles"></div><div class="lr"></div>');
      jQuery(this).find('th').each(function (i, elem) {
        var num = i + 1;
        jQuery(this).parent().parent().parent('table').find('td:nth-child(' + num + ')').attr('data-label', $.trim(jQuery(elem).text()) + ":");
      });
    });

    // Feature 50 50
    feature_50_50();

    jQuery(window).on("resize", function () {
      feature_50_50();
    });


    // Feature Split Tabs JS
    var $feature_split_tabs = jQuery(".feature-split-tabs");

    $feature_split_tabs.children(".tab").hide();
    $feature_split_tabs.children(".tab:first-child").show();
    jQuery(".tabs-dd").find("select").on("change", function () {
      jQuery(this).parents(".paragraph--type--feature-split").find(".feature-split-tabs .tab").hide();
      jQuery(this).parents(".paragraph--type--feature-split").find(".feature-split-tabs ." + jQuery(this).val() + "").show();
    });

    /** Form Label Functionatlity **/
    var formObj = {
      addClass: function (elem, name) {
        var classes = elem.className.split(' '),
          cIndex = classes.indexOf(name);
        if (cIndex === -1) {
          classes.push(name);
        }
        elem.className = classes.join(' ');
        return this;
      },  // END addClass

      removeClass: function (elem, name) {
        var classes = elem.className.split(' '),
          cIndex = undefined;

        function recursive() {
          // use a recursive function to remove all instances
          // of the class name
          cIndex = classes.indexOf(name);
          if (cIndex >= 0) {
            classes.splice(cIndex, 1);
            recursive();
          }
        }

        recursive();
        elem.className = classes.join(' ');
        return this;
      },  // END removeClass

      inputFocus: function (input, label) {
        var _this = this;
        input.addEventListener('focus', function () {
          _this.addClass(label, 'active')
            .addClass(label, 'transition')
            .removeClass(label, 'inactive');
        });
        return this;
      },  // END inputFocus

      inputBlur: function (input, label) {
        var _this = this;
        input.addEventListener('blur', function () {
          if (this.value === '') {
            _this.addClass(label, 'inactive')
              .addClass(label, 'transition')
              .removeClass(label, 'active');
          }
        });
        return this;
      }       // END inputBlur

    };

    var labels = document.getElementsByTagName('label'),
      id = '',
      label = undefined,
      input = undefined,
      type = undefined;
    for (var i = 0, x = labels.length; i < x; i++) {
      label = labels[i];
      id = label.getAttribute('for') || '';
      input = document.getElementById(id);
      type = input.getAttribute('type') || input.tagName;
      type = type.toLowerCase();
      // Make sure the input exists
      // Select, Radio, and Checkboxes would need something
      //      different
      if (input && (type === 'password' || type === 'text' || type === 'email')) {
        formObj.inputFocus(input, label)
        formObj.inputBlur(input, label);
        if (input.value === '') {
          formObj.addClass(label, 'inactive');
        }
        else {
          formObj.addClass(label, 'active');
        }
      }// END if( input && type )
    }// END for( labels )

    jQuery(document).find("form label").each(function () {

      if (jQuery(this).next().attr("autofocus") === "autofocus") {
        jQuery(this).addClass("active").removeClass("inactive");
      }

      if (jQuery(this).next().attr("type") != "password" && jQuery(this).parent().find('input').attr("value") != "" && jQuery(this).parent().find('input').attr("value") != "undefined") {
        jQuery(this).addClass("active").removeClass("inactive");
      }
    });

    /** End Form Label Functionatlity **/

    function hamburger_voiceover() {
      if (window.innerWidth < 767) {
        var h_h = $(".region-header").height();
        $(".js-voiceover-hamburger").css("height", h_h + 'px');
      }
    }

    hamburger_voiceover();

    $(window).on("resize", function () {
      hamburger_voiceover();
    });


  });

  /**
   *
   * @type {{attach: Drupal.behaviors.AdditionalJS.attach}}
   */
  Drupal.behaviors.AdditionalJS = {
    attach: function (context, settings) {

      $(once('AdditionalJS', 'html', context)).each(function (element) {
        $(context).on("click", ".js-menuButton", function () {
          $('.searchBarHeader .menuButton').trigger("click");
        });

        $('.menuExpand').on('click', function (e) {
          e.preventDefault();

          if ($(window).width() > 991) {
            $(".menuExpand:not(.focused)").removeClass("focused");
            $(this).toggleClass("focused");
            if ($(this).hasClass("focused")) {
              $(this).attr("aria-expanded", "true");
              $(".midCol .subMenu").removeClass("active");
              $(".midCol ." + $(this).attr("data-submenu")).addClass("active").children(".subMenuCloseButton").focus();
            }
            else {
              $(".midCol ." + $(this).attr("data-submenu")).removeClass("active");
              $(this).attr("aria-expanded", "false");
            }
          }
          else {

            $('.menuExpand').removeClass('focused');
            $(this).attr("aria-expanded", 'true');
            $(this).addClass('focused');
            // if ($(window).width() < 991) {
            $('.subMenu').eq($(this).parents('span').index()).attr('aria-hidden', 'false').addClass("active");
            $(".subMenu.active").find(".subMenuCloseButton").attr("tabindex", "0").focus();
            // }
          }
        });
        $('.subMenuCloseButton').on('click', function () {
          $(".menuExpand").attr("aria-expanded", 'false');
          $('.subMenu').removeClass('active').attr('aria-hidden', 'true');
          $(this).parent().removeClass('active').attr('aria-hidden', 'true');
          setTimeout(function () {
            $(".focused.menuExpand").focus().removeClass("focused").attr("aria-expanded", 'false');
          }, 100);
        });

        // New Teriary Menus
        $('.subMenuExpand').on("click", function (e) {
          e.preventDefault();
          var submenu = '.' + $(this).attr('data-submenu');
          var link = $(this).siblings('a.subMenuLink');

          $(this).toggleClass('active');
          $('.subMenuExpand').not(this).removeClass('active');
          $(link).toggleClass('active');
          $('.subMenuLink').not(link).removeClass('active');
          $(submenu).toggleClass('active');
          $('.subSubMenu').not(submenu).removeClass('active');
        });
      });

      /**
       * Detect Browsers
       */
        // Get the brower type & add class to body.
      var browserName = (function (agent) {
          switch (true) {
            case agent.indexOf("edge") > -1:
              return "MS-Edge";

            case agent.indexOf("edg/") > -1:
              return "Edge chromium-based";

            case agent.indexOf("opr") > -1 && !!window.opr:
              return "Opera";

            case agent.indexOf("chrome") > -1 && !!window.chrome:
              return "Chrome";

            case agent.indexOf("trident") > -1:
              return "MS-IE";

            case agent.indexOf("firefox") > -1:
              return "Firefox";

            case agent.indexOf("safari") > -1:
              return "Safari";

            default:
              return "other";
          }
        })(window.navigator.userAgent.toLowerCase());

      $("body").addClass(browserName);


      /**
       * Android/Iphone Accessibility
       */

      const top_level = $(".firstCol .top-level-menus");
      top_level.find("a > button.menuExpand").on("focus", function (e) {
        top_level.find("a").removeClass("disabledEvents");
        $(this).parent().addClass("disabledEvents");
      });
      top_level.find("a").on("focus", function (e) {
        top_level.find("a").removeClass("disabledEvents");
      });
      $(document).on("keydown", ".firstCol .top-level-menus a.disabledEvents", function (event) {
        if (event.keyCode == 13) {
          event.preventDefault();
          return false;
        }
      });

      /**
       * Sliding Card Close button accessiblity
       */
      $(document).on("keydown", '.slidingCard .face.back .faceback-close', function (e) {
        if (e.keyCode == 9) {
          setTimeout(function () {
            if (jQuery(".slidingCards .slick-active.slidingCard .face.back").find("h4 > a").length > 0) {
              jQuery(".slidingCards .slick-active.slidingCard .face.back").find("h4 > a").focus();
            }
            else {
              jQuery(".slidingCards .slick-active.slidingCard .face.back").find("button.faceback-close").focus();
            }
          }, 100);
        }
        if (e.keyCode == 13) {
          setTimeout(function () {
            jQuery(".slidingCards .slidingCard.slick-active .face.front button.rightplus").focus();
          }, 100);
        }
      });

      /**
       * Sliding Card Close button
       */
      $(context).on("click", '.slidingCard .face.back .faceback-close', function () {
        $(this).parents('.slidingCard').removeClass('flipped');
        $('.slidingCard .face.back button').attr("tabindex", "-1");
        $('.slidingCard .face.back a').attr("tabindex", "-1");
        $('.slidingCard.slick-active .rightplus').attr("tabindex", "0");
      });

      //Searchable  Card click
      $(once('seachableCardClick', document)).on("click", ".searchableCard", function (e) {
        // Allow clicking the top link.
        if (e.target.localName == 'a') {
          return;
        }

        e.preventDefault();
        var $card = $(this);
        if ($card.hasClass("flipped")) {
          $card.removeClass('flipped');
          $card.find(".face.back").attr("aria-hidden", "true");
          $(this).attr("aria-expanded", 'false');
          //.addClass('unflipped');
        }
        else {
          $card.addClass('flipped');
          $card.find(".face.back").attr("aria-hidden", "false");
          $(this).attr("aria-expanded", 'true');
          //.removeClass('unflipped');
          $card.height($card.find('.face.back').outerHeight());
        }
      });
      $(context).on("click keydown", '.searchableCard .face.back .faceback-close', function (event) {
        if ((event.type == 'click') || (event.type == 'keydown' && event.which == 13)) {
          $(this).parents('.searchableCard').removeClass('flipped');
          $('.searchableCard .face.back button').attr("tabindex", "-1");
          $('.searchableCard .face.back a').attr("tabindex", "-1");
          $('.searchableCard .rightplus').attr("tabindex", "0");
          $(this).parents('.searchableCard').height(235);
        }
      });

      $('.searchableCard .face.back').mouseleave(function () {
        $(this).parents('.searchableCard').removeClass('flipped');
        $(this).find(".bottomRightPlus").attr("aria-expanded", "false");
        $('.searchableCard').find(".face.back").attr("aria-hidden", "true");
        $(this).parents('.searchableCard').height(235);
      });

      function menuHover() {
        $(".firstCol .top-level-menus > span", context).mouseenter(function () {
          if ($(window).width() > 991) {
            $(".firstCol .top-level-menus span").removeClass("focused");
            $('.subMenu').removeClass('active').attr('aria-hidden', 'true');
            $('.subMenu').eq($(this).index()).addClass("active").attr('aria-hidden', 'false');
            $(".firstCol .top-level-menus a .menuExpand").attr('aria-expanded', 'false');
            $(this).find('.menuExpand').attr('aria-expanded', 'true');
          }
        });
      }

      menuHover();

      $('.search', context).unbind().on('click', function (e) {
        e.preventDefault();
        $('.search-menu-block').toggleClass('active');
        $(this).find("img").toggleClass('active');
        if ($(this).find("img").hasClass('active')) {
          $(this).find("img").attr("src", "/themes/custom/cfmg/assets/images/Close.svg");
          $(this).attr("aria-expanded", "true");
          $('.search-menu-block').attr("aria-hidden", "false").find(".form-type-textfield input").focus();
        }
        else {
          $(this).find("img").attr("src", "/themes/custom/cfmg/assets/images/Search.png");
          $(this).attr("aria-expanded", "false");
          $('.search-menu-block').attr("aria-hidden", "true");
        }

        $('.search span').toggleClass('hide');
      });

      // Menu Button

      $('.searchBarHeader .menuButton', context).unbind().on('click', function (e) {
        e.preventDefault();

        /**
         * Active Hamburger Menu
         */
        $("body").toggleClass("active-hamburger");
        $('.menuButton').toggleClass('active');
        $('.menu').toggleClass('active');
        $('.subMenu').each(function () {
          $(this).removeClass('active');
        });
        if ($('.menu').hasClass("active")) {
          $('.menu.main-nav-menu').attr("aria-hidden", "false");
          $(this).attr("aria-expanded", "true");
          $('.menu  a').attr("tabindex", "0");
          $('.menu  button').attr("tabindex", "0");
        }
        else {
          $('.menu.main-nav-menu').attr("aria-hidden", "true");
          $(this).attr("aria-expanded", "false");
          $('.menu  a').attr("tabindex", "-1");
          $('.menu  button').attr("tabindex", "-1");
        }

        if ($("body").hasClass("active-hamburger")) {
          $(".js-voiceover-hamburger").append('<a href="#" class="js-menuButton active" aria-label="Show Navigation Menu" aria-expanded="true" tabindex="0" role="button"><div class="line1"></div><div class="line2"></div><div class="line3"></div><div class="line4"></div></a>');
        }
        else {
          $("header").children(".js-voiceover-hamburger").find(".js-menuButton").remove();
        }

        //$('nav').toggleClass('active');
      });

      // Hero Animation
      // var hflArray = $('.hfl');
      // var hfrArray = $('.hfr');
      // var hblArray = $('.hbl');
      // var hbrArray = $('.hbr');
      // var i = 0;
      // var j = 0;
      // var k = 0;
      // var l = 0;
      //
      // function LoopForever(array, startingPoint, arrayName) {
      //   switch (arrayName) {
      //     case "hfl":
      //       if (startingPoint < array.length - 1) {
      //         i++;
      //       }
      //       else {
      //         i = 0;
      //       }
      //       array.eq(i - 1).css('display', 'none');
      //       array.eq(i).css('display', 'block');
      //       break;
      //     case "hfr":
      //       if (startingPoint < array.length - 1) {
      //         j++;
      //       }
      //       else {
      //         j = 0;
      //       }
      //       array.eq(j - 1).css('display', 'none');
      //       array.eq(j).css('display', 'block');
      //       break;
      //     case "hbl":
      //       if (startingPoint < array.length - 1) {
      //         k++;
      //       }
      //       else {
      //         k = 0;
      //       }
      //       array.eq(k - 1).css('display', 'none');
      //       array.eq(k).css('display', 'block');
      //       break;
      //     case "hbr":
      //       if (startingPoint < array.length - 1) {
      //         l++;
      //       }
      //       else {
      //         l = 0;
      //       }
      //       array.eq(l - 1).css('display', 'none');
      //       array.eq(l).css('display', 'block');
      //       break;
      //   }
      // }
      //
      // LoopForever(hflArray, i, "hfl");
      // LoopForever(hfrArray, j, "hfr")
      // setTimeout(function () {
      //   LoopForever(hfrArray, j, "hfr")
      // }, 3000);
      // setTimeout(function () {
      //   LoopForever(hblArray, k, "hbl")
      // }, 6000);
      // setTimeout(function () {
      //   LoopForever(hbrArray, l, "hbr")
      // }, 9000);
      //
      // var interval = self.setInterval(function () {
      //   LoopForever(hflArray, i, "hfl")
      // }, 12000);
      // var interval2 = self.setInterval(function () {
      //   setTimeout(function () {
      //     LoopForever(hfrArray, j, "hfr")
      //   }, 3000)
      // }, 12000);
      // var interval3 = self.setInterval(function () {
      //   setTimeout(function () {
      //     LoopForever(hblArray, k, "hbl")
      //   }, 6000)
      // }, 12000);
      // var interval4 = self.setInterval(function () {
      //   setTimeout(function () {
      //     LoopForever(hbrArray, l, "hbr")
      //   }, 9000)
      // }, 12000);


      // Quicklinks
      jQuery(document, context).find(".quickLinks a").each(function () {
        if (window.location.pathname == jQuery(this).attr("href")) {
          jQuery(this).addClass("current-active-link");
          jQuery(this).attr("aria-current", "page");
        }
      });

      // Concentration grid
      jQuery(".view-concentrations-grid").find(".form-checkbox").on("change", function () {
        jQuery(this).parents(".view-filters").find(".input-btn > input").trigger("click");
      });


      // Pager JS
      jQuery(".arrowRow").find(".dividedArrowLine > a").unbind().on("click", function (e) {
        e.preventDefault();
        jQuery(this).parent().parent().next().find(".page-" + jQuery(this).data('page') + " > a span").trigger("click");
      });

      jQuery(".arrowRow").find(".prevArrow, .nextArrow").unbind().on("click", function (e) {
        e.preventDefault();
        if (jQuery(this).hasClass("nextArrow")) {
          jQuery(this).parent().next().find(".pager__items .pager__item--next span").trigger("click");
        }
        else {
          jQuery(this).parent().next().find(".pager__items .pager__item--previous span").trigger("click");
        }
      });
      // Article Grid Filter
      var list = [];
      jQuery('select[data-drupal-selector="edit-tags"] option[selected="selected"], select[data-drupal-selector="edit-field-categories-target-id"] option[selected="selected"]').each(function () {
        fliterTags(jQuery(this).attr('value'));
      });


      jQuery('.view-article-grid-filter .blog__filterTags--tag').unbind().on('click', function () {
        jQuery(this).toggleClass('active');
        var tid = jQuery(this).data("tid");
        if (jQuery(this).hasClass("active")) {
          jQuery('select[data-drupal-selector="edit-tags"] option[value="' + tid + '"]').attr("selected", "selected");
        }
        else {
          jQuery('select[data-drupal-selector="edit-tags"] option[value="' + tid + '"]').removeAttr("selected");
        }
        jQuery(".view-articles-grid").find("#views-exposed-form-articles-grid-block .form-actions input[value=\"Apply\"]").trigger("click");
      });

      jQuery('.view-article-grid-filter .blog__filterControls--clear').unbind().on('click', function (e) {
        e.preventDefault();
        jQuery(".view-articles-grid").find("#views-exposed-form-articles-grid-block .form-actions input[value=\"Reset\"]").trigger("click");
      });

      $(once('faqFilterTags', 'body')).on('click', '.view-faq-filter .faq__filterTags--tag', function () {
        jQuery(this).toggleClass('active');
        var tid = jQuery(this).data("tid");
        if (jQuery(this).hasClass("active")) {
          jQuery('select[data-drupal-selector="edit-category"] option[value="' + tid + '"]').attr("selected", "selected");
        }
        else {
          jQuery('select[data-drupal-selector="edit-category"] option[value="' + tid + '"]').removeAttr("selected");
        }
        jQuery(".view-faqs-accordion").find("#views-exposed-form-faqs-accordion-index-block .form-actions input[value=\"Apply\"]").trigger("click");
      });

      jQuery('.view-faq-filter .faq__filterControls--clear').unbind().on('click', function (e) {
        e.preventDefault();
        jQuery(".view-faqs-accordion").find("#views-exposed-form-faqs-accordion-index-block .form-actions input[value=\"Reset\"]").trigger("click");
      });

      // JQuery Article-grid featured Image
      jQuery(".blog__card--head").each(function () {
        jQuery(this).css("background-image", "url(" + jQuery(this).attr('article-grid') + ")");
      });

      // Related Article BG
      jQuery(".view-related-articles, .view-blogger-articles ").find(".blog__card--head").each(function () {
        jQuery(this).css("background-image", "url(" + jQuery(this).attr("article-img") + ")");
      });

      // Announcement card BG
      jQuery(".announcements__card--picture").each(function () {
        jQuery(this).css("background-image", "url(" + jQuery(this).attr("data-img") + ")");
      });

      // JQuery Article featured Image
      jQuery(".blogHero").each(function () {
        jQuery(this).css("background-image", "url(" + jQuery(this).data('img') + ")");
      });

      // Concentration Card BG Image
      jQuery(".searchCardsContainer .searchableCard").each(function () {
        var card_bg = jQuery(this).children(".card-bg");
        var img_src = card_bg.attr("data-img");
        card_bg.css("background-image", "url(" + img_src + ")");
      });

    }
  };

})(jQuery, Drupal, once);
